#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;

int a[22][22];
int dx[4]={0, 0, 1, -1}, dy[4]={1, -1, 0, 0};
int n, m;

void backtracking(int x, int y)
{
    bool cooked=true;

    for(int i=0; i<4; i++)
    {
        int nx=x+dx[i], ny=y+dy[i];

        if(nx>=0 && nx<n && ny>=0 && ny<m && a[nx][ny]!=1)
        {
            a[nx][ny]++;
            backtracking(nx, ny);
            a[nx][ny]=0;
            cooked=false;
        }
    }

    if(cooked==true) return;
}

int main()
{
    srand(time(nullptr));


    cin>>n>>m;

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            char c;
            cin>>c;
            if(c=='X') a[i][j]=1;
            ///else a[i][j]=0;
        }
    }

    int x=0, y=0;

    for(x=0; x<n; x++)
    {
        for(y=0; y<m; y++)
        {
            if(a[x][y]==0) break;
        }
    }



    a[x][y]=2;

    backtracking(x, y);

    if(a[x][y]!=2) cout<<0<<endl;
    else cout<<1<<endl;

    return 0;
}
