#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int countbadwalls(vector<vector<bool>>& grid, int x, int y){
    int c = 0;
    if (grid[x+1][y])
        c++;
    if (grid[x][y+1])
        c++;
    if (grid[x-1][y])
        c++;
    if (grid[x][y-1])
        c++;
    return c;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<bool>> grid(n+2, vector<bool>(m+2, 1));
    for (int i = 1;i <= n;i ++){
        for (int j = 1;j <= m;j ++){
            char a;
            cin >> a;
            if (a == '.')
                grid[i][j] = 0;
        }
    }
    int countbadpoints = 0;
    for (int i = 1;i <= n;i ++){
        for (int j = 1;j <= m;j ++){
            if (!grid[i][j]){
                if (countbadwalls(grid, i, j) == 3)
                    countbadpoints ++;
            }
        }
    }
    if (countbadpoints < 2)
        cout << 0;
    else
        cout << 1;
    return 0;
}
