#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    vector<ll> dp(n+1);
    ll x, y, z, m;
    cin >> a[0] >> a[1] >> x >> y >> z >> m;
    dp[1] = a[0];
    dp[2] = dp[1] + a[1];
    for (ll i = 2;i < n;i ++){
        a[i] = (a[i-2]*x + a[i-1]*y + z) % m;
        dp[i+1] = dp[i] + a[i];
    }
    ll count = 0;
    for (ll r = 0;r < n;r ++){
        if (dp[r+1] < 2*k) continue;
        for (ll l = 0;l <= r;l ++ ){
            if (dp[r+1] - dp[l] < 2*k) break;
            for (ll idx = l;idx <= r;idx ++){
                if (min(dp[idx+1]-dp[l], dp[r+1]-dp[idx+1]) >= k ){
                    count ++;
                    break;
                }
            }
        }
    }
    cout << count;
    return 0;
}
