#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;

const int maxc = 20;
bool lab[maxc + 2][maxc + 2], t;
int used[maxc + 2][maxc + 2];
int hr, hc;
pair <int, int> p[4] = {{0, -1}, {1, 0}, {0, 1}, {-1, 0}};

void rec (int x, int y, int wx, int wy) {
    used[x][y]++;
    if(x == hr && y == hc && (wx != 0 || wy != 0)) {
        hr = -20;
        hc = -20;
        t = true;
        return;
    }
    for(int i = 0; i < 4; i++) {
        int helpx = p[i].first;
        int helpy = p[i].second;
        if((wx != -helpx || wy != -helpy) && lab[x + helpx][y + helpy] && used[x + helpx][y + helpy] == 0) {
            rec(x + helpx, y + helpy, helpx, helpy);
            break;
        }
    }
    for(int i = 0; i < 4; i++) {
        int helpx = p[i].first;
        int helpy = p[i].second;
        if((wx != -helpx || wy != -helpy) && lab[x + helpx][y + helpy] && used[x + helpx][y + helpy] < 2) {
            rec(x + helpx, y + helpy, helpx, helpy);
            break;
        }
    }
    if(t) return;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    char s;
    for(int r = 1; r <= n; r++) {
        for(int c = 1; c <= m; c++) {
            cin >> s;
            if(s == '.') {
                lab[r][c] = true;
                hr = r;
                hc = c;
            }
        }
    }
    rec(hr, hc, 0, 0);
    if(hr == -20 && hc == -20) {
        cout << 0;
        return 0;
    }
    cout << 1;
    return 0;
}
