#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 26000;
bool prime[MAXN];
bool superPrime[MAXN];
int pref_primes[MAXN];
int pref_superPrimes[MAXN];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int q, l, r;
    cin >> q;

    for (int i = 2; i <= MAXN; i++) prime[i] = true;
    for (int i = 2; i * i <= MAXN; i++) {
        if (prime[i]) {
            for (int j = i * i; j <= MAXN; j += i) {
                prime[j] = false;
            }
        }
    }

    for (int i = 1; i <= MAXN; i++) {
        pref_primes[i] = pref_primes[i - 1] + prime[i];
    }

    for (int i = 1; i <= MAXN; i++) {
        pref_superPrimes[i] = pref_superPrimes[i - 1] + prime[pref_primes[i]];
    }

    for (int i = 0; i < q; i++) {
        cin >> l >> r;
        cout << pref_superPrimes[r] - pref_superPrimes[l - 1] << endl;
    }
    return 0;
}

