#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;
const int N=1e5+1;
int broiProhodimi=0;
int broiMinati=0;
int plusI[]= {0, 0,1,-1};
int plusJ[]= {1,-1,0, 0};
bool matrix[21][21];//1-stava,0-nestava
int makeZbrPos(int posoka)
{
    return (posoka>2)*4+1-posoka;
}
void rekursia(int i,int j,int posoka)
{
    //int zbrPosoka=(posoka>2)*2+2-posoka+(posoka>2)*2;
    ++broiMinati;
    bool promeneno=false;
    int zbrPosoka=makeZbrPos(posoka);
    for(int p=0; p<4; ++p)
    {
        if(zbrPosoka==p)continue;
        int nI=i+plusI[p];
        int nJ=j+plusJ[p];
        if(matrix[nI][nJ])
        {
            if(broiMinati==broiProhodimi)
            {
                cout<<0<<endl;
                exit(0);
            }
            promeneno=true;
            rekursia(nI,nJ,p);

        }
    }
    if(!promeneno)
    {
        cout<<1<<endl;
        exit(0);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n,m;
    cin>>n>>m;
    char e;
    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            cin>>e;
            if(e=='.')
            {
                ++broiProhodimi;
                matrix[i][j]=true;
            }
        }
    }

/*
    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            cerr<<matrix[i][j];
        }
        cerr<<endl;
    }
*/



    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            if(matrix[i][j])
            {
                for(int p=0; p<4; ++p)
                {
                    int nI=i+plusI[p];
                    int nJ=j+plusJ[p];
                    if(matrix[nI][nJ])
                    {
                        rekursia(i,j,makeZbrPos(p));

                    }
                }
            }
        }
    }
    cout<<0<<endl;
    return 0;
}
