#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;
const int R=26e3+2;
int erat[R];
bool eratB[R];
int superPrimes[R];
void eratosten()
{
    for(int i=2;i<R;++i)
    {
        if(eratB[i])continue;
        for(int j=i*2;j<=R;j+=i)
            eratB[j]=1;
    }
}
void init()
{
    eratB[0]=1;
    eratB[1]=1;
    eratosten();
    for(int i=1;i<R;++i)
    {
        erat[i]=erat[i-1]+!eratB[i];
        //cerr<<erat[i]<<" ";
        superPrimes[i]=!eratB[erat[i]];
        superPrimes[i]+=superPrimes[i-1];
    }
    //cerr<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    init();
    int n;
    cin>>n;
    for(int i=0;i<n;++i)
    {
        int a,b;
        cin>>a>>b;
        cout<<superPrimes[b]-superPrimes[a-1]<<endl;
    }
    return 0;
}
