#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;
using LL=long long;
const int N=1e7+1;
LL segA,k;
LL boks;//боксьор 1
LL boks2;//боксьор 2
LL broiInteresni=0;
LL redica[N];
void popilniRPlus()
{
    if(boks<=boks2)
    {
        boks+=segA;
    }
    else
        boks2+=segA;
    broiInteresni+=(min(boks,boks2)>=k);
}


void popilniL(int r)
{
    LL bokso=boks;
    LL bokso2=boks2;
    for(int ptr_a=0; ptr_a<r; ++ptr_a)
    {
        if(bokso>=bokso2)
        {
            bokso-=redica[ptr_a];
        }
        else
            bokso2-=redica[ptr_a];
        //cerr<<"    "<<ptr_a+1<<" "<<r<<" "<<bokso<<" "<<bokso2<<endl;
        broiInteresni+=(min(bokso,bokso2)>=k);
    }
}


void popilni(int r)
{
    popilniRPlus();
    popilniL(r);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    LL n,x,y,z,m;
    cin>>n>>k;
    LL predA,pred2A;
    cin>>pred2A>>predA>>x>>y>>z>>m;
    segA=pred2A;
    redica[0]=segA;
    popilni(0);
    //cerr<<0<<" "<<0<<" "<<boks<<" "<<boks2<<endl;
    if(n==1)
    {
        cout<<broiInteresni<<endl;
        return 0;
    }
    segA=predA;
    redica[1]=segA;
    popilni(1);
    //cerr<<0<<" "<<1<<" "<<boks<<" "<<boks2<<endl;
    for(int r=2; r<n; ++r)
    {
        segA=(pred2A*x+predA*y+z)%m;
        redica[r]=segA;
        //cerr<<"segA:"<<segA<<endl;
        swap(pred2A,predA);
        predA=segA;
        popilni(r);
        //cerr<<0<<" "<<r<<" "<<boks<<" "<<boks2<<endl;
    }
    cout<<broiInteresni<<endl;
    return 0;
}
