#include <bits/stdc++.h>
#define endl '\n'
#define ll long long
using namespace std;

vector<int> prefix(26005);
vector<int> prosti(26005);

void Eratosten() {
    prosti[0] = -1;
    prosti[1] = -1;

    for(int i = 2; i < sqrt(prosti.size()); i ++) {
        if(prosti[i] == 0) {
            for(int j = i * i; j < prosti.size(); j += i) {
                prosti[j] = i;
            } 
        }
    }
}

void pref() {
    for(int i = 1; i < 26005; i ++) {
        prefix[i] = prefix[i - 1];
        if(prosti[i] == 0) prefix[i] ++;
    }
}

int brSuper(int l, int r) {
    int br = 0;

    for(int i = l; i <= r; i ++) {
        if(prosti[prefix[i]] == 0) {
            br ++;
            //cout << "(" << i << ", " << prefix[i] << ") "; 
        }
    }

    return br;
}

int main() {

    Eratosten();
    pref();

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int Q, l , r;
    cin >> Q;
    

    for(int i = 0; i < Q; i ++) {
        cin >> l >> r;
        cout << brSuper(l, r) << endl;
    }

    return 0;
}